# -*- coding: utf-8 -*-
import random

from docopt import Dict as DocOptDict
from irc3.plugins.command import command
from irc3.utils import IrcString

from . import DatabasePlugin


class Rape(DatabasePlugin):
    requires = ['irc3.plugins.command',
                'nxy.plugins.database']

    @command
    def owe(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Shows how much a nick owes.

        %%owe [<nick>...]
        """
        nick = ' '.join(args.get('<nick>')) or mask.nick

        if nick.startswith('@'):
            nick = nick.lstrip('@').strip()

        self.cur.execute('select amount from owes where nick = ?', [nick])
        owes = self.cur.fetchone()

        if owes:
            total = '5${total}'.format(total=owes['amount'])
        else:
            total = '3$0'

        return '{nick} owes: \x03{total}\x03'.format(nick=nick, total=total)

    @command
    def rape(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Rapes a nick and eventually charge for it.

        %%rape <nick>
        """
        nick = args.get('<nick>') or mask.nick
        fine = random.randint(1, 500)
        rand = random.randint(0, 3)

        if rand in (0, 1):
            self.cur.execute('select amount from owes where nick = ?', [nick])
            owe = self.cur.fetchone()

            if owe:
                total = owe['amount'] + fine
                self.cur.execute('update owes set amount = ? where nick = ?',
                                 [total, nick])
            else:
                total = fine
                self.cur.execute('insert into owes (nick, amount) values '
                                 '(?, ?)', [nick, total])
                self.con.commit()

            reason = ('raping', 'being too lewd and getting raped')[rand]
            action = 'fines {nick} \x02${fine}\x02 for {reason}. You owe: ' \
                     '\x0304${total}\x03'.format(nick=nick,
                                                 fine=fine,
                                                 reason=reason,
                                                 total=total)
        else:
            action = 'rapes {nick}'.format(nick=nick)
        self.bot.action(channel, action)
