# -*- coding: utf-8 -*-
import irc3
import random

from docopt import Dict as DocOptDict
from irc3.plugins.command import command
from irc3.utils import IrcString

from . import Plugin

RAINBOW = (5, 3, 7, 8, 9, 3, 10, 12, 2, 6, 13)
RAINBOW_LEN = len(RAINBOW)


@irc3.plugin
class Useless(Plugin):
    requires = ['irc3.plugins.command']

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<channel>\S+) :(?P<msg>huehuehue)$')
    def huehuehue(self, channel: str, msg: str):
        """Returns a huehuehue when someone writes it."""
        self.bot.privmsg(channel, msg)

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<channel>\S+) :reeeeee$')
    def reeeeee(self, channel: str):
        """Returns a REEEE."""
        self.bot.privmsg(channel, 'REEEEEEEEEEEEEEEEEEEEEEEEEEEE')

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<channel>\S+) :same$')
    def same(self, channel: str):
        """Returns a plain same when a user writes same."""
        self.bot.privmsg(channel, 'same')

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<channel>\S+) :\[(?P<msg>.*)\]$')
    def intensifies(self, channel: str, msg: str):
        """String with brackets around will be returned with INTENSIFIES."""
        self.bot.privmsg(channel, '\x02[{msg} INTENSIFIES]'.format(
            msg=msg.upper()))

    @command
    def storyofpomfface(self, mask: IrcString, channel: IrcString,
                        args: DocOptDict):
        """Story of pomf face.

        %%storyofpomfface
        """
        for face in (':O C==3', ':OC==3', ':C==3', ':C=3', ':C3', ':3'):
            self.bot.privmsg(channel, face)

    @command
    def choose(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Decides between items separated by comma.

        %%choose <items>...
        """
        choice = random.choice(' '.join(args['<items>']).split(','))
        return '{nick}, I\'d choose: {choice}'.format(nick=mask.nick,
                                                      choice=choice.strip())

    @command
    def jn(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Decides between yes and no (for a question).

        %%jn <question>
        %%jn
        """
        choice = random.choice(['3Ja', '5Nein'])
        return '{nick}: \x02\x03{choice}'.format(nick=mask.nick,
                                                 choice=choice)

    @command
    def kiss(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Kisses a user.

        %%kiss <nick>
        """
        return '(づ｡◕‿‿◕｡)\x033。。・゜゜・。。・゜❤\x0F {nick} \x033❤'.format(
            nick=args['<nick>'])

    @command
    def hug(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Hugs a user.

        %%hug <nick>
        """
        return '\x033♥♡❤♡♥\x0F {nick} \x033♥♡❤♡♥'.format(nick=args['<nick>'])

    @command
    def bier(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Gives nick a beer.

        %%bier <nick>
        """
        return '\x01ACTION schenkt ein kühles blondes an {nick} aus.\x01' \
            .format(nick=args['<nick>'])

    @command
    def fucken(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Kills and fucks a nick.

        %%fucken <nick>
        """
        return '\x01ACTION fuckt {nick} und tötet {nick} anschließend.\x01' \
            .format(nick=args['<nick>'])

    @command
    def anhero(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Kicks a nick.

        %%anhero
        """
        self.bot.privmsg(channel, 'Sayonara bonzai-chan...')
        self.bot.kick(channel, mask.nick)

    @command
    def sudoku(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Kicks a nick.

        %%sudoku
        """
        self.anhero(mask, channel, args)

    @command
    def hack(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Hacks (a user).

        %%hack [<nick>]
        """
        nick = args.get('<nick>') or ''
        return 'hacking{nick}...'.format(nick=' %s' % nick if nick else '')

    @command
    def gay(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Make someone gay (alias to rainbow)

        %%gay <word>...
        """
        return self.rainbow(mask, channel, args)

    @command
    def rainbow(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Colorize a word in rainbow colors.

        %%rainbow <word>...
        """
        last = 0
        word = []
        for char in ' '.join(args.get('<word>')):
            if char != ' ':
                char = self._rainbow(last, char)
                last += 1
            word.append(char)
        return ''.join(word)

    @command
    def wrainbow(self, mask: IrcString, channel: IrcString, args: DocOptDict):
        """Colorize words in a sentence with rainbow colors.

        %%wrainbow <words>...
        """
        return ' '.join([self._rainbow(i, word) for i, word
                         in enumerate(args['<words>'])])

    @staticmethod
    def _rainbow(i, char):
        return '\x03{color}{char}'.format(color=RAINBOW[i % RAINBOW_LEN],
                                          char=char)
